Index: src/molecule_fragmentation.cpp
===================================================================
--- src/molecule_fragmentation.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule_fragmentation.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -1536,5 +1544,5 @@
   struct UniqueFragments FragmentSearch;
 
-  Log() << Verbose(0) << "Begin of FragmentBOSSANOVA." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of FragmentBOSSANOVA." << endl);
 
   // FragmentLowerOrdersList is a 2D-array of pointer to MoleculeListClass objects, one dimension represents the ANOVA expansion of a single order (i.e. 5)
@@ -1586,6 +1594,6 @@
 
       // create top order where nothing is reduced
-      Log() << Verbose(0) << "==============================================================================================================" << endl;
-      Log() << Verbose(0) << "Creating KeySets of Bond Order " << Order << " for " << *Walker << ", " << (RootStack.size()-RootNr) << " Roots remaining." << endl; // , NumLevels is " << NumLevels << "
+      DoLog(0) && (Log() << Verbose(0) << "==============================================================================================================" << endl);
+      DoLog(0) && (Log() << Verbose(0) << "Creating KeySets of Bond Order " << Order << " for " << *Walker << ", " << (RootStack.size()-RootNr) << " Roots remaining." << endl); // , NumLevels is " << NumLevels << "
 
       // Create list of Graphs of current Bond Order (i.e. F_{ij})
@@ -1597,5 +1605,5 @@
 
       // output resulting number
-      Log() << Verbose(1) << "Number of resulting KeySets is: " << NumMoleculesOfOrder[RootNr] << "." << endl;
+      DoLog(1) && (Log() << Verbose(1) << "Number of resulting KeySets is: " << NumMoleculesOfOrder[RootNr] << "." << endl);
       if (NumMoleculesOfOrder[RootNr] != 0) {
         NumMolecules = 0;
@@ -1614,7 +1622,7 @@
     }
   }
-  Log() << Verbose(0) << "==============================================================================================================" << endl;
-  Log() << Verbose(1) << "Total number of resulting molecules is: " << TotalNumMolecules << "." << endl;
-  Log() << Verbose(0) << "==============================================================================================================" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "==============================================================================================================" << endl);
+  DoLog(1) && (Log() << Verbose(1) << "Total number of resulting molecules is: " << TotalNumMolecules << "." << endl);
+  DoLog(0) && (Log() << Verbose(0) << "==============================================================================================================" << endl);
 
   // cleanup FragmentSearch structure
@@ -1634,5 +1642,5 @@
   Free(&NumMoleculesOfOrder);
 
-  Log() << Verbose(0) << "End of FragmentBOSSANOVA." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "End of FragmentBOSSANOVA." << endl);
 };
 
@@ -1649,4 +1657,5 @@
   atom *Walker = NULL;
   atom *OtherWalker = NULL;
+  double * const cell_size = World::get()->cell_size;
   double *matrix = ReturnFullMatrixforSymmetric(cell_size);
   enum Shading *ColorList = NULL;
@@ -1657,5 +1666,5 @@
   bool flag = true;
 
-  Log() << Verbose(2) << "Begin of ScanForPeriodicCorrection." << endl;
+  DoLog(2) && (Log() << Verbose(2) << "Begin of ScanForPeriodicCorrection." << endl);
 
   ColorList = Calloc<enum Shading>(AtomCount, "molecule::ScanForPeriodicCorrection: *ColorList");
@@ -1675,5 +1684,5 @@
           OtherBinder = Binder->next; // note down binding partner for later re-insertion
           unlink(Binder);   // unlink bond
-          Log() << Verbose(2) << "Correcting at bond " << *Binder << "." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "Correcting at bond " << *Binder << "." << endl);
           flag = true;
           break;
@@ -1691,5 +1700,5 @@
       //Log() << Verbose(3) << "Translation vector is ";
       Translationvector.Output();
-      Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << endl);
       // apply to all atoms of first component via BFS
       for (int i=AtomCount;i--;)
@@ -1713,5 +1722,5 @@
       link(Binder, OtherBinder);
     } else {
-      Log() << Verbose(3) << "No corrections for this fragment." << endl;
+      DoLog(3) && (Log() << Verbose(3) << "No corrections for this fragment." << endl);
     }
     //delete(CompStack);
@@ -1722,4 +1731,4 @@
   Free(&ColorList);
   Free(&matrix);
-  Log() << Verbose(2) << "End of ScanForPeriodicCorrection." << endl;
-};
+  DoLog(2) && (Log() << Verbose(2) << "End of ScanForPeriodicCorrection." << endl);
+};
Index: src/molecule_geometry.cpp
===================================================================
--- src/molecule_geometry.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/molecule_geometry.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -15,4 +15,5 @@
 #include "memoryallocator.hpp"
 #include "molecule.hpp"
+#include "World.hpp"
 
 /************************************* Functions for class molecule *********************************/
@@ -26,4 +27,5 @@
   bool status = true;
   const Vector *Center = DetermineCenterOfAll();
+  double * const cell_size = World::get()->cell_size;
   double *M = ReturnFullMatrixforSymmetric(cell_size);
   double *Minv = InverseMatrix(M);
@@ -46,4 +48,5 @@
 {
   bool status = true;
+  double * const cell_size = World::get()->cell_size;
   double *M = ReturnFullMatrixforSymmetric(cell_size);
   double *Minv = InverseMatrix(M);
@@ -101,9 +104,9 @@
 {
   int Num = 0;
-  atom *ptr = start->next;  // start at first in list
+  atom *ptr = start;  // start at first in list
 
   Center.Zero();
 
-  if (ptr != end) {   //list not empty?
+  if (ptr->next != end) {   //list not empty?
     while (ptr->next != end) {  // continue with second if present
       ptr = ptr->next;
@@ -226,4 +229,5 @@
 void molecule::TranslatePeriodically(const Vector *trans)
 {
+  double * const cell_size = World::get()->cell_size;
   double *M = ReturnFullMatrixforSymmetric(cell_size);
   double *Minv = InverseMatrix(M);
@@ -252,4 +256,5 @@
 {
   atom *Walker = start;
+  double * const cell_size = World::get()->cell_size;
   double *matrix = ReturnFullMatrixforSymmetric(cell_size);
   double *inversematrix = InverseMatrix(cell_size);
@@ -275,5 +280,5 @@
               if ((fabs(tmp)) > BondDistance) {
                 flag = false;
-                Log() << Verbose(0) << "Hit: atom " << Walker->Name << " in bond " << *(*Runner) << " has to be shifted due to " << tmp << "." << endl;
+                DoLog(0) && (Log() << Verbose(0) << "Hit: atom " << Walker->Name << " in bond " << *(*Runner) << " has to be shifted due to " << tmp << "." << endl);
                 if (tmp > 0)
                   Translationvector.x[j] -= 1.;
@@ -286,7 +291,7 @@
         Testvector.MatrixMultiplication(matrix);
         Center.AddVector(&Testvector);
-        Log() << Verbose(1) << "vector is: ";
+        DoLog(1) && (Log() << Verbose(1) << "vector is: ");
         Testvector.Output();
-        Log() << Verbose(0) << endl;
+        DoLog(0) && (Log() << Verbose(0) << endl);
 #ifdef ADDHYDROGEN
         // now also change all hydrogens
@@ -298,7 +303,7 @@
             Testvector.MatrixMultiplication(matrix);
             Center.AddVector(&Testvector);
-            Log() << Verbose(1) << "Hydrogen vector is: ";
+            DoLog(1) && (Log() << Verbose(1) << "Hydrogen vector is: ");
             Testvector.Output();
-            Log() << Verbose(0) << endl;
+            DoLog(0) && (Log() << Verbose(0) << endl);
           }
         }
@@ -347,11 +352,11 @@
   }
   // print InertiaTensor for debugging
-  Log() << Verbose(0) << "The inertia tensor is:" << endl;
+  DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << endl);
   for(int i=0;i<NDIM;i++) {
     for(int j=0;j<NDIM;j++)
-      Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ";
-    Log() << Verbose(0) << endl;
-  }
-  Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ");
+    DoLog(0) && (Log() << Verbose(0) << endl);
+  }
+  DoLog(0) && (Log() << Verbose(0) << endl);
 
   // diagonalize to determine principal axis system
@@ -365,14 +370,14 @@
 
   for(int i=0;i<NDIM;i++) {
-    Log() << Verbose(1) << "eigenvalue = " << gsl_vector_get(eval, i);
-    Log() << Verbose(0) << ", eigenvector = (" << evec->data[i * evec->tda + 0] << "," << evec->data[i * evec->tda + 1] << "," << evec->data[i * evec->tda + 2] << ")" << endl;
+    DoLog(1) && (Log() << Verbose(1) << "eigenvalue = " << gsl_vector_get(eval, i));
+    DoLog(0) && (Log() << Verbose(0) << ", eigenvector = (" << evec->data[i * evec->tda + 0] << "," << evec->data[i * evec->tda + 1] << "," << evec->data[i * evec->tda + 2] << ")" << endl);
   }
 
   // check whether we rotate or not
   if (DoRotate) {
-    Log() << Verbose(1) << "Transforming molecule into PAS ... ";
+    DoLog(1) && (Log() << Verbose(1) << "Transforming molecule into PAS ... ");
     // the eigenvectors specify the transformation matrix
     ActOnAllVectors( &Vector::MatrixMultiplication, (const double *) evec->data );
-    Log() << Verbose(0) << "done." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "done." << endl);
 
     // summing anew for debugging (resulting matrix has to be diagonal!)
@@ -399,11 +404,11 @@
     }
     // print InertiaTensor for debugging
-    Log() << Verbose(0) << "The inertia tensor is:" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << endl);
     for(int i=0;i<NDIM;i++) {
       for(int j=0;j<NDIM;j++)
-        Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ";
-      Log() << Verbose(0) << endl;
-    }
-    Log() << Verbose(0) << endl;
+        DoLog(0) && (Log() << Verbose(0) << InertiaTensor[i*NDIM+j] << " ");
+      DoLog(0) && (Log() << Verbose(0) << endl);
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
   }
 
@@ -428,7 +433,7 @@
 
   // rotate on z-x plane
-  Log() << Verbose(0) << "Begin of Aligning all atoms." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Begin of Aligning all atoms." << endl);
   alpha = atan(-n->x[0]/n->x[2]);
-  Log() << Verbose(1) << "Z-X-angle: " << alpha << " ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Z-X-angle: " << alpha << " ... ");
   while (ptr->next != end) {
     ptr = ptr->next;
@@ -446,12 +451,12 @@
   n->x[0] =  cos(alpha) * tmp +  sin(alpha) * n->x[2];
   n->x[2] = -sin(alpha) * tmp +  cos(alpha) * n->x[2];
-  Log() << Verbose(1) << "alignment vector after first rotation: ";
+  DoLog(1) && (Log() << Verbose(1) << "alignment vector after first rotation: ");
   n->Output();
-  Log() << Verbose(0) << endl;
+  DoLog(0) && (Log() << Verbose(0) << endl);
 
   // rotate on z-y plane
   ptr = start;
   alpha = atan(-n->x[1]/n->x[2]);
-  Log() << Verbose(1) << "Z-Y-angle: " << alpha << " ... ";
+  DoLog(1) && (Log() << Verbose(1) << "Z-Y-angle: " << alpha << " ... ");
   while (ptr->next != end) {
     ptr = ptr->next;
@@ -470,8 +475,8 @@
   n->x[2] = -sin(alpha) * tmp +  cos(alpha) * n->x[2];
 
-  Log() << Verbose(1) << "alignment vector after second rotation: ";
+  DoLog(1) && (Log() << Verbose(1) << "alignment vector after second rotation: ");
   n->Output();
-  Log() << Verbose(1) << endl;
-  Log() << Verbose(0) << "End of Aligning all atoms." << endl;
+  DoLog(1) && (Log() << Verbose(1) << endl);
+  DoLog(0) && (Log() << Verbose(0) << "End of Aligning all atoms." << endl);
 };
 
